typedef signed char     int8;
typedef signed short    int16;
typedef signed long     int32;
typedef unsigned char   uint8;
typedef unsigned short  uint16;
typedef unsigned long   uint32;
typedef signed char     bool;


typedef struct PARAM {
    int8   wave;              // +0
    int8   level;             // +1
    uint32 freq1;             // +2
    uint32 freq2;             // +6
    int16  phase;             // +10
    int8   oncycle;           // +12
    int8   offcycle;          // +13
} PARAM;


typedef struct PARAMSG {
    uint8  Level256;          // +0
    uint16 Levelsg;           // +1:l +2:h
    uint8  Freq1sgh;          // +3:h
    uint16 Freq1sg;           // +4:l +5:m
    uint8  Freq2sgh;          // +6:h
    uint16 Freq2sg;           // +7:l +8:m
    uint16 Phasesg_hosei;     // +9:m +10:h   1/FS ̕␳  sine 2ch Ŏg
    int8   Oncycle;           // +11
    int8   Offcycle;          // +12
    uint16 Phasesg;           // +13:m +14:h  1/FS ̕␳Ȃ  twotone Ŏg
} PARAMSG;

void sine_test( void ) ;
void noise_test( void ) ;
void pinknoise_test( void ) ;
void twotone_test( void ) ;
void sin2ch( void ) ;
void etcwave( void ) ;    // 1:square 2:saw 3:triangle
void toneburst( void ) ;

